<?php
if ( ! defined( 'ABSPATH' ) )
{
	exit;
}

require_once FLX_WOO_PATH . 'cfg/cfg.php';

class FlxWooAdmin
{
	private $fields = [
	];

	private $tabs = [
		'contact-us' => 'Contact Us'
	];

	private $sections = [
		'keys' => 'Keys'
	];


	private $tab = '';


	public function __construct()
	{
		$this->tab = $this->get_tab();
	}

	public function __destruct()
	{
	}


	private function get_tab()
	{
		$tab = ! empty( $_GET['tab'] ) ? sanitize_text_field( wp_unslash( $_GET['tab'] ) ) : '';
		$tab = 'contact-us' === $tab ? $tab : 'contact-us';

		return $tab;
	}


	private function title_callback( $matches )
	{
		return $matches[1] . '<hr>' . $matches[2];
	}


	private function echo_contact_us()
	{
		echo '
		<p><strong>Email:</strong> rickey29@gmail.com</p>';
	}


	public function settings_callback()
	{
		echo '
<div class="wrap">
	<h2>Flx Woo Settings</h2>';

		if ( ! empty( $_GET['settings-updated'] ) )
		{
			echo '
	<div class="notice notice-success is-dismissible">
		<p>Your settings have been updated!</p>
	</div>';
		}

		echo '
	<nav class="nav-tab-wrapper">';

		foreach ( $this->tabs as $key => $value )
		{
			echo '
		<a href="?page=flx-woo&tab=' . esc_attr( $key ) . '" class="nav-tab' . ( ( $key === $this->tab ) ? ' nav-tab-active' : '' ) . '">' . esc_html( $value ) . '</a>';
		}

		echo '
	</nav>
	<div class="tab-content">';

		if ( 'contact-us' === $this->tab )
		{
			$this->echo_contact_us();
		}
		else
		{
			$this->echo_contact_us();
		}

		echo '
	</div>
</div>';
	}

	public function add_menu()
	{
		if ( ! current_user_can( 'manage_options' ) )
		{
			return;
		}

		// add_menu_page( string $page_title, string $menu_title, string $capability, string $menu_slug, callable $function = '', string $icon_url = '', int $position = null )
		add_menu_page( 'Flx Woo', 'Flx Woo', 'manage_options', 'flx-woo', [ $this, 'settings_callback' ] );
	}


	public function section_callback( $args )
	{
	}

	public function field_callback( $args )
	{
		$value = get_option( $args['uid'] );
		if ( empty( $value ) )
		{
			$value = isset( $args['default'] ) ? $args['default'] : '';
		}

		if ( ! isset( $args['placeholder'] ) )
		{
			$args['placeholder'] = '';
		}

		switch ( $args['type'] )
		{
			case 'text':
			case 'password':
			case 'number':
				printf( '<input name="%1$s" id="%1$s" type="%2$s" placeholder="%3$s" value="%4$s" size="64" />', esc_attr( $args['uid'] ), esc_attr( $args['type'] ), esc_attr( $args['placeholder'] ), esc_attr( $value ) );
				break;

			case 'textarea':
				printf( '<textarea name="%1$s" id="%1$s" placeholder="%2$s" rows="4" cols="64">%3$s</textarea>', esc_attr( $args['uid'] ), esc_attr( $args['placeholder'] ), esc_textarea( $value ) );
				break;

			case 'select':
			case 'multiselect':
				if ( ! empty( $args['options'] ) && is_array( $args['options'] ) )
				{
					$options_markup = '';
					foreach ( $args['options'] as $key => $label )
					{
						if ( ! empty( $value ) )
						{
							$options_markup .= sprintf( '<option value="%s" %s>%s</option>', esc_attr( $key ), selected( $value[ array_search( $key, $value, TRUE ) ], $key, FALSE ), esc_html( $label ) );
						}
						else
						{
							$options_markup .= sprintf( '<option value="%s">%s</option>', esc_attr( $key ), esc_html( $label ) );
						}
					}

					$attributes = '';
					if ( 'multiselect' === $args['type'] )
					{
						$attributes = ' multiple="multiple" ';
					}

					printf( '<select name="%1$s[]" id="%1$s" %2$s>%3$s</select>', esc_attr( $args['uid'] ), esc_attr( $attributes ), $options_markup );
				}
				break;

			case 'radio':
			case 'checkbox':
				if ( ! empty( $args['options'] ) && is_array( $args['options'] ) )
				{
					$options_markup = '';
					$iterator = 0;
					foreach ( $args['options'] as $key => $label )
					{
						$iterator++;
						if ( ! empty( $value ) )
						{
							$options_markup .= sprintf( '<input id="%1$s_%6$s" name="%1$s[]" type="%2$s" value="%3$s" %4$s /><label for="%1$s_%6$s"> %5$s</label><br>', esc_attr( $args['uid'] ), esc_attr( $args['type'] ), esc_attr( $key ), checked( $value[ array_search( $key, $value, TRUE ) ], $key, FALSE ), wp_kses_post( $label ), esc_attr( $iterator ) );
						}
						else
						{
							$options_markup .= sprintf( '<input id="%1$s_%5$s" name="%1$s[]" type="%2$s" value="%3$s" /><label for="%1$s_%5$s"> %4$s</label><br>', esc_attr( $args['uid'] ), esc_attr( $args['type'] ), esc_attr( $key ), wp_kses_post( $label ), esc_attr( $iterator ) );
						}
					}

					printf( '<fieldset>%s</fieldset>', $options_markup );
				}
				break;

			case 'media-uploader':
				printf( '<input id="%1$s" type="text" name="%1$s" value="%2$s" placeholder="%3$s" size="64" /> <input id="%4$s" type="button" class="button-primary" value="Choose Image" />', esc_attr( $args['uid'] ), esc_attr( $value ), esc_attr( $args['placeholder'] ), esc_attr( $args['button'] ) );
				break;

			case 'color-picker':
				printf( '<input id="%1$s" type="text" name="%1$s" value="%2$s" class="flx-woo-color-picker" data-default-color="#ffffff" />', esc_attr( $args['uid'] ), esc_attr( $value ) );
				break;
		}

		if ( ! empty( $args['helper'] ) )
		{
			$helper = $args['helper'];
			printf( '<span class="helper">%s</span>', wp_kses_post( $helper ) );
		}

		if ( ! empty( $args['supplimental'] ) )
		{
			$supplimental = $args['supplimental'];
			printf( '<p class="description">%s</p>', wp_kses_post( $supplimental ) );
		}
	}

	public function register_settings()
	{
		if ( ! current_user_can( 'manage_options' ) )
		{
			return;
		}

		foreach ( $this->fields as $field )
		{
			if ( empty( $field['tab'] ) || $this->tab !== $field['tab'] )
			{
				continue;
			}
			$tab = $field['tab'];

			if ( empty( $field['uid'] ) )
			{
				continue;
			}
			$uid = $field['uid'];

			if ( empty( $field['label'] ) )
			{
				continue;
			}
			$label = $field['label'];

			if ( empty( $field['section'] ) )
			{
				continue;
			}
			$section = $field['section'];

			$title = ! empty( $this->sections[$section] ) ? $this->sections[$section] : '';


			// add_settings_section( string $id, string $title, callable $callback, string $page )
			add_settings_section( $section, $title, [ $this, 'section_callback' ], $tab );

			// add_settings_field( string $id, string $title, callable $callback, string $page, string $section = 'default', array $args = array() )
			add_settings_field( $uid, $label, [ $this, 'field_callback' ], $tab, $section, $field );

			// register_setting( string $option_group, string $option_name, array $args = array() )
			register_setting( 'flx-woo', $uid );
		}
	}
}


if ( ! is_admin() )
{
	return;
}

$flx_woo_admin = new FlxWooAdmin();

add_action( 'admin_menu', [ $flx_woo_admin, 'add_menu' ] );
add_action( 'admin_init', [ $flx_woo_admin, 'register_settings' ] );
