<?php
if ( ! defined( 'ABSPATH' ) )
{
	exit;
}

require_once FLX_WOO_PATH . 'cfg/cfg.php';

class FlxWooFlx
{
	public function __construct()
	{
	}

	public function __destruct()
	{
	}


	private function get_server_list()
	{
		$list = [];

		$num = wp_rand( 1, 6 );
		if ( 1 === $num )
		{
			$list = [ FLX_WOO_FLX_SERVER_1, FLX_WOO_FLX_SERVER_2, FLX_WOO_FLX_SERVER_3 ];
		}
		elseif ( 2 === $num )
		{
			$list = [ FLX_WOO_FLX_SERVER_1, FLX_WOO_FLX_SERVER_3, FLX_WOO_FLX_SERVER_2 ];
		}
		elseif ( 3 === $num )
		{
			$list = [ FLX_WOO_FLX_SERVER_2, FLX_WOO_FLX_SERVER_1, FLX_WOO_FLX_SERVER_3 ];
		}
		elseif ( 4 === $num )
		{
			$list = [ FLX_WOO_FLX_SERVER_2, FLX_WOO_FLX_SERVER_3, FLX_WOO_FLX_SERVER_1 ];
		}
		elseif ( 5 === $num )
		{
			$list = [ FLX_WOO_FLX_SERVER_3, FLX_WOO_FLX_SERVER_1, FLX_WOO_FLX_SERVER_2 ];
		}
		else
		{
			$list = [ FLX_WOO_FLX_SERVER_3, FLX_WOO_FLX_SERVER_2, FLX_WOO_FLX_SERVER_1 ];
		}

		return $list;
	}

	private function fetch( $url, $args )
	{
		$response = wp_remote_post( $url, $args );

		$http_code = wp_remote_retrieve_response_code( $response );
		if ( 200 !== $http_code )
		{
			return;
		}

		$body = wp_remote_retrieve_body( $response );
		$body = json_decode( $body, TRUE );
		if ( empty( $body ) || ! is_array( $body ) )
		{
			return;
		}

		return $body;
	}

	private function query( $route, $args )
	{
		list( $server1, $server2, $server3 ) = $this->get_server_list();

		$url = $server1 . FLX_WOO_FLX_API . $route;
		$body = $this->fetch( $url, $args );
		if ( ! empty( $body ) )
		{
			return $body;
		}

		if ( $server1 === $server2 )
		{
			return;
		}

		$url = $server2 . FLX_WOO_FLX_API . $route;
		$body = $this->fetch( $url, $args );
		if ( ! empty( $body ) )
		{
			return $body;
		}

		if ( $server2 === $server3 )
		{
			return;
		}

		$url = $server3 . FLX_WOO_FLX_API . $route;
		$body = $this->fetch( $url, $args );
		if ( ! empty( $body ) )
		{
			return $body;
		}

		return;
	}

	public function get_page( $route, $body )
	{
		$body = wp_json_encode( $body );

		$args = [
			'headers' => [
				'Content-Type' => 'application/json; charset=utf-8',
				'Accept-Encoding' => 'gzip'
			],
			'method' => 'POST',
			'data_format' => 'body',
			'body' => $body
		];

		$body = $this->query( $route, $args );

		if ( empty( $body['page'] ) || ! is_string( $body['page'] ) )
		{
			return;
		}
		$page = trim( $body['page'] );

		return $page;
	}
}
